/*
 * end-of-atomic.c
 *
 * This is the magic function which is called at the end of every atomic
 * call to the server. It is responisble for
 *	Free:ing all tmp_alloc:ated memory
 *	Throw out some cached data if necessary
 *	Forget some old texts if necessary
 *	Save some items to disk if saving
 *
 * idle is TRUE if the server has no pending calls. That might be a good time
 * to forget old texts.
 */

#include <kom-types.h>
#include "smalloc.h"
#include "text-garb.h"
#include "config.h"
#include "disk-cache.h"
#include "cache.h"

long
end_of_atomic( Bool  idle )
{
    int timeout = TIMEOUT;

    free_tmp();
    cache_limit_size();

    if ( idle )
	if ( garb_text() == FALSE )
	    timeout = GARBTIMEOUT;

    if ( sync_part() == FALSE )
	timeout = SYNCTIMEOUT;

    return timeout;
}
